Are you opening a **BUG REPORT** or a **FEATURE REQUEST / CODE CHANGE**?

There is a section for each below.  Please complete the appropriate section and remove the other one.

We realize there is a lot of data requested here. We ask only that you do your best to provide as much information as possible so we can better help you.


# BUG REPORT

* [ ] I have ensured that the issue isn't already reported
* [ ] I have confirmed that the issue is reproducible with the latest released version
* [ ] I have deleted the **FEATURE REQUEST / CODE CHANGE** section

## Summary
* Provide a general summary of the issue in the title above

## Expected Behavior
* What should happen?

## Actual Behavior
* What happens instead of the expected behavior?
* Is something broken, or not behaving as you expected?
* Attach a screenshot or recording as appropriate.

## Possible Solution
* Not obligatory, but suggest a fix/reason for the bug

## Steps to Reproduce
* How would you describe your issue to someone who doesn’t know you or your project?
* Try to write a sequence of steps that anybody can repeat to see the issue.
* Be specific! If the bug cannot be reproduced, your issue may be closed.
* Provide a link to a live example, include code to reproduce, or direct us to any relevant files as applicable
* This guide has some additional good information: https://stackoverflow.com/help/mcve

---

* [ ] Include the contents of your _package.json_ file
* [ ] Steps to reproduce:
  1.
  2.
  3.
  4.
  ...


## Context
* How has this issue affected you? What are you trying to accomplish?
* Providing context helps us come up with a solution that is most useful in the real world.

## Environment

(answer all that are applicable)

* [ ] I am using the latest released version (can check with `npm ls <package-name>`)
* I am using these browsers:
  * [ ] Latest Chrome
  * [ ] Latest Firefox
* [ ] My version of `Node` is:
* [ ] My version of `npm` is:
* [ ] My OS is:
* [ ] Include the contents of your _package.json_ file




# FEATURE REQUEST / CODE CHANGE

* [ ] I have deleted the **BUG REPORT** section

## Summary
* [ ] Provide a general summary of the requested feature in the title above
* [ ] Provide a one-paragraph explanation of the requested feature:


## Motivation
* Describe the big picture of your feature to communicate why it should be added.
  * Why are we doing this?
  * What use cases does it support?
  * What is the expected outcome?

## Detailed design
This is the bulk of the Feature Request / Code Change.

Explain the design in enough detail for somebody familiar with this addon, the UI Platform ecosystem, and Ember.js to understand, and for somebody familiar with the implementation to implement. This should get into specifics and corner-cases, and include examples of how the feature is used. Any new terminology should be defined here.

## How we teach this

* What names and terminology work best for these concepts and why?
* How should this feature be introduced and taught to existing users?

## Drawbacks

* Why should we ***not*** do this? Please consider the impact...
  * ...on teaching this
  * ...on the integration of this feature with other existing and planned features
  * ...on the impact of the API churn on existing apps
  * ...etc.
* There are tradeoffs to choosing any path, please attempt to identify them here.

## Alternatives

* What other designs have been considered? What is the impact of not doing this?
* This section could also include prior art, that is, how other addons or libraries in the same domain have solved this problem.

## Unresolved questions

* Optional, but suggested for first drafts. What parts of the design are still TBD?
